"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Equatable = void 0;
const iEquatable_1 = require("./iEquatable");
class Equatable {
    equals(other) {
        if (!("properties" in other && Array.isArray(other.properties))) {
            return false;
        }
        if (this.properties.length !== other.properties.length) {
            return false;
        }
        return this.properties.every((property, index) => {
            return (0, iEquatable_1.equals)(property, other.properties[index]);
        });
    }
    get properties() {
        const properties = [];
        for (const key in this) {
            properties.push(this[key]);
        }
        return properties;
    }
}
exports.Equatable = Equatable;
//# sourceMappingURL=equatable.js.map